using System;
using System.Data;
using System.Drawing;
using System.Web.UI;
using Telerik.Web.UI;
using Telerik.Web.UI.GridExcelBuilder;

public partial class _Default : Page
{
    protected void RadGrid1_NeedDataSource(object source, GridNeedDataSourceEventArgs e)
    {
        DataTable dataTable = new DataTable();
        dataTable.Columns.Add("col1");
        dataTable.Columns.Add("col2");

        for (int i = 0; i < 20; i++)
        {
            dataTable.Rows.Add(new object[] { i, "FirstLine<br/>SecondLine" });
        }

        ((RadGrid)source).DataSource = dataTable;
    }

    protected void Button1_Click(object sender, EventArgs e)
    {
        RadGrid1.ExportSettings.Excel.Format = GridExcelExportFormat.ExcelML;
        RadGrid1.ExportSettings.ExportOnlyData = true;
        RadGrid1.MasterTableView.ExportToExcel();
    }

    protected void RadGrid1_ExcelMLExportRowCreated(object source, GridExportExcelMLRowCreatedArgs e)
    {
        if (e.RowType == GridExportExcelMLRowType.DataRow)
        {
            CellElement cellElement = e.Row.Cells.GetCellByName("col2");
            //apply the custom styles
            if (cellElement.StyleValue == "itemStyle")
            {
                cellElement.StyleValue = "MyItemCustomStyle";
            }
            else if (cellElement.StyleValue == "alternatingItemStyle")
            {
                cellElement.StyleValue = "MyAlternatingItemCustomStyle";
            }
            //replace the characters
            cellElement.Data.DataItem = ((string)cellElement.Data.DataItem).Replace("<br/>", "&#10");
        }
    }

    protected void RadGrid1_ExcelMLExportStylesCreated(object source, GridExportExcelMLStyleCreatedArgs e)
    {
        //define some styling
        foreach (StyleElement style in e.Styles)
        {
            if (style.Id == "headerStyle")
            {
                style.FontStyle.Bold = true;
                style.FontStyle.Color = Color.Gainsboro;
                style.InteriorStyle.Color = Color.Wheat;
                style.InteriorStyle.Pattern = InteriorPatternType.Solid;
            }
            else if (style.Id == "itemStyle")
            {
                style.InteriorStyle.Color = Color.WhiteSmoke;
                style.InteriorStyle.Pattern = InteriorPatternType.Solid;
            }
            else if (style.Id == "alternatingItemStyle")
            {
                style.InteriorStyle.Color = Color.LightGray;
                style.InteriorStyle.Pattern = InteriorPatternType.Solid;
            }
        }

        //create custom style for the multi row column
        StyleElement myStyle =
            new StyleElement("MyItemCustomStyle");
        myStyle.AlignmentElement.VerticalAlignment = VerticalAlignmentType.Bottom;
        myStyle.AlignmentElement.Attributes["ss:WrapText"] = "1";

        myStyle.InteriorStyle.Color = Color.WhiteSmoke;
                myStyle.InteriorStyle.Pattern = InteriorPatternType.Solid;
        e.Styles.Add(myStyle);

        StyleElement myAltStyle =
           new StyleElement("MyAlternatingItemCustomStyle");
        myAltStyle.AlignmentElement.VerticalAlignment = VerticalAlignmentType.Bottom;
        myAltStyle.AlignmentElement.Attributes["ss:WrapText"] = "1";
        myAltStyle.InteriorStyle.Color = Color.LightGray;
                myAltStyle.InteriorStyle.Pattern = InteriorPatternType.Solid;

        e.Styles.Add(myAltStyle);
    }

    protected void RadGrid1_GridExporting(object source, GridExportingArgs e)
    {
        //modify the generated document's output 
        if (e.ExportType == ExportType.ExcelML)
        {
            e.ExportOutput = e.ExportOutput.Replace("amp;", "");
        }
    }
}